// GENERATED BY THE COMMAND ABOVE; DO NOT EDIT
// This file was generated by swaggo/swag

package docs

import (
	"bytes"
	"encoding/json"
	"strings"

	"github.com/alecthomas/template"
	"github.com/swaggo/swag"
)

var doc = `{
    "schemes": {{ marshal .Schemes }},
    "swagger": "2.0",
    "info": {
        "description": "{{.Description}}",
        "title": "{{.Title}}",
        "termsOfService": "https://themicroservice.co",
        "contact": {
            "name": "API Support",
            "email": "api@themicroservice.co"
        },
        "license": {
            "name": "Apache 2.0",
            "url": "http://www.apache.org/licenses/LICENSE-2.0.html"
        },
        "version": "{{.Version}}"
    },
    "host": "{{.Host}}",
    "basePath": "{{.BasePath}}",
    "paths": {
        "/rating": {
            "post": {
                "description": "Rates a unit based record given a configuration and the units consumed.",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "kill-billing"
                ],
                "summary": "Record rating",
                "parameters": [
                    {
                        "description": "Rate record",
                        "name": "rating",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/rate.Rating"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/rate.RatingResult"
                        }
                    }
                }
            }
        }
    },
    "definitions": {
        "rate.Rate": {
            "type": "object",
            "properties": {
                "initial_price": {
                    "type": "number"
                },
                "maximum_chargeable_units": {
                    "type": "integer"
                },
                "maximum_price": {
                    "type": "number"
                },
                "minimum_chargeable_units": {
                    "type": "integer"
                },
                "minimum_price": {
                    "type": "number"
                },
                "steps": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/rate.Step"
                    }
                }
            }
        },
        "rate.Rating": {
            "type": "object",
            "properties": {
                "rate": {
                    "type": "object",
                    "$ref": "#/definitions/rate.Rate"
                },
                "unit_label": {
                    "type": "string"
                },
                "unit_label_plural": {
                    "type": "string"
                },
                "units": {
                    "type": "integer"
                }
            }
        },
        "rate.RatingResult": {
            "type": "object",
            "properties": {
                "final_price": {
                    "type": "number"
                },
                "units_charged": {
                    "type": "integer"
                }
            }
        },
        "rate.Step": {
            "type": "object",
            "properties": {
                "block_price": {
                    "type": "number"
                },
                "blocks_in_step": {
                    "type": "integer"
                },
                "units_per_block": {
                    "type": "integer"
                }
            }
        }
    }
}`

type swaggerInfo struct {
	Version     string
	Host        string
	BasePath    string
	Schemes     []string
	Title       string
	Description string
}

// SwaggerInfo holds exported Swagger Info so clients can modify it
var SwaggerInfo = swaggerInfo{
	Version:     "1.0",
	Host:        "https://api.themicroservice.co/rating/",
	BasePath:    "/",
	Schemes:     []string{},
	Title:       "Simple Record Rating",
	Description: "Just a simple record rating service,",
}

type s struct{}

func (s *s) ReadDoc() string {
	sInfo := SwaggerInfo
	sInfo.Description = strings.Replace(sInfo.Description, "\n", "\\n", -1)

	t, err := template.New("swagger_info").Funcs(template.FuncMap{
		"marshal": func(v interface{}) string {
			a, _ := json.Marshal(v)
			return string(a)
		},
	}).Parse(doc)
	if err != nil {
		return doc
	}

	var tpl bytes.Buffer
	if err := t.Execute(&tpl, sInfo); err != nil {
		return doc
	}

	return tpl.String()
}

func init() {
	swag.Register(swag.Name, &s{})
}
